/**
 *
 *   (c)2007, Bentski
 *   Homepage: http://kzlt.bentski.lt/
 *   Server: cs.bentski.lt:27015
 *
 *   HTTP downloader. Allows to download files from the web.
 *
 */

#include <amxmodx>
#include <sockets>
#include <httpdl>

new dlinfo[MAX_DOWNLOADS + 1][5];
new dlpath[MAX_DOWNLOADS + 1][256];
new ndownloading;
new fwd_dlcomplete, fwd_result;

public plugin_init() {
	register_plugin("HTTP Download", "1.0", "Bentski");
	
	fwd_dlcomplete = CreateMultiForward("dlcomplete", ET_IGNORE, FP_CELL, FP_STRING);
}

public plugin_natives() {
	register_library("httpdl");
	register_native("download", "native_download", 1);
}

public native_download(url[], path[]) {
	new slot = 0;
	while(slot <= MAX_DOWNLOADS && dlinfo[slot][0] != 0)
		slot++;
	if(slot == MAX_DOWNLOADS) {
		server_print("Download limit reached (%d)", MAX_DOWNLOADS);
		return 0;
	}

	param_convert(1);
	param_convert(2);
	
	new u[256], p[256];
	copy(u, 7, url);
	if(equal(u, "http://"))
		copy(u, 248, url[7]);
	else copy(u, 255, url);

	new pos = 0;
	new len = strlen(u);
	while (++pos < len && u[pos] != '/') { }
	copy(p, 255, u[pos + 1]);
	copy(u, pos, u);

	new error = 0;
	new socket = dlinfo[slot][2] = socket_open(u, 80, SOCKET_TCP, error);
	switch(error) {
		case 0: {
			new msg[512];
			format(msg, 511, "GET /%s HTTP/1.1^r^nHost: %s^r^n^r^n", p, u);
			socket_send(socket, msg, 512);
			copy(dlpath[slot], 255, path);
			dlinfo[slot][3] = fopen(path, "wb");
			dlinfo[slot][0] = 1;
			dlinfo[slot][4] = 0;
			ndownloading++;
			if(ndownloading == 1)
				set_task(0.2, "download_task", 3318, _, _, "b");
			new id = dlinfo[slot][1] = random_num(1, 65535);
			return id;
		}
		case 1: server_print("[HTTP] Blad przy tworzeniu stocka");
		case 2: server_print("[HTTP] Nie mozna znalezc serwera");
		case 3: server_print("[HTTP] Blad polaczenia z: %s:80", u);
	}

	return 0;
}

public download_task() {
	for(new i = 0; i < MAX_DOWNLOADS; i++) {
		if(dlinfo[i][0] == 0)
			continue;
		new socket = dlinfo[i][2];
		new f = dlinfo[i][3];
		if(socket_change(socket)) {
			new buffer[1024];
			new len = socket_recv(socket, buffer, 1024);
			if(dlinfo[i][4] == 0) { // if first packet then cut the header
				new pos = contain(buffer, "^r^n^r^n");
				if(pos > -1) {
					for(new j = pos + 4; j < len; j++)
						fputc(f, buffer[j]);
					dlinfo[i][4]++;
					continue;
				}
			}
			// is there a better way to write binary data to a file? :S
			for(new j = 0; j < len; j++)
				fputc(f, buffer[j]);
			dlinfo[i][4]++;
			continue;
		}
		fclose(f);
		ExecuteForward(fwd_dlcomplete, fwd_result, dlinfo[i][1], dlpath[i]);
		dlinfo[i][0] = 0;
		ndownloading--;
		if(ndownloading == 0)
			remove_task(3318);
		socket_close(socket);
	}
}